#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <strings.h>
#include <signal.h>
#include <wait.h>
#include <sys/time.h>
#include <sys/types.h>
#include <regex.h>
#include "config.h"


int randget(int maxx);
char *scanme(char *tmpfname, char *buff);
char *extch(char *buff);
char *don(char *buff);
char *parcala(char *str, char *delim);
char *mailit(char *buff, char *fout);

int main(int argc, char *argv[]){
   char *buff=malloc(MAXSIZE), *dest=malloc(MAXSIZE), *tmpfname=malloc(200), *mboxname=malloc(200);
   FILE *fpd;
   int i=0;
   char *found;
   char *username = getenv("LOGNAME");
   int argvint=strlen(username)+strlen(TMPMAILDIR);
   pid_t child_pid;
   int child_status;

   fread(buff, MAXSIZE, 1, stdin);
	if (strlen(username)==0) printf("%d\n",strlen(username));
	strcat (tmpfname,TMPMAILDIR);
	strcat(tmpfname,username);
	while (i<=10){
		tmpfname[argvint+i]=randget(26)+64;
		i++;
	}

   child_pid = fork();

      switch (child_pid) {
            case -1:
                perror("Can't create child process\n");
                exit(1);
            case 0:
		found = scanme(tmpfname,buff);
		if (found!=NULL) {
				sprintf (mboxname,"%s%s",INFDIR,username);
				unlink (tmpfname);
				fpd = fopen(mboxname,"a");
				fwrite (buff,strlen(buff),1,fpd);
				fclose(fpd);
				dest = mailit(buff,found);

		} else 	dest = don(buff);


				#ifdef PROCMAIL
					fpd = popen (PROCMAIL,"w");
				#else
				#ifdef	USERMBOXES
					sprintf (mboxname,"%s%s",USERMBOXES,username);
					fpd = fopen (mboxname,"a");
					chmod (mboxname,0400);
				#endif
				#endif		
				if (fpd){
					fwrite (dest,strlen(dest),1,fpd);
					fclose(fpd);
					unlink (tmpfname);
				}
		unlink (tmpfname);
                exit(0);
            default:
                wait(&child_status);
        }


unlink (tmpfname);
exit(0);
return 1;
}

int randget(int maxx){
        int j;
        struct timeval tp;
        double msec = 0.0;
        char *ret=malloc(30);
        if (gettimeofday((struct timeval *) &tp, (NULL)) == 0) {
                msec = (double) (tp.tv_usec / 1000000.00);
        }
        if (msec >= 1.0) msec -= (long) msec;

        if (msec < 0) msec *= (-1);

        sprintf(ret, "%f", msec * 10000000);
        srand(atoi(ret));
        j = (int) (maxx * (rand()/(RAND_MAX+1.0)));
        if (j == 0) j=1;
        return j;
}
char *extch(char *buff){
	return don(buff);
}

